"""

Joueurs pré-programmés

Chaque joueur implémente une méthode 'jouer' qui prend en paramètre 'info', variable renvoyée par le module morpion

"""

import random

"""
----------------
Joueur Aléatoire
----------------

Joue complètement aléatoirement

"""

class Joueur_Aleatoire():
    def __init__(self):
        pass

    def jouer(self, info):
        return random.choice(info['legal_actions'])

"""
-------------
Joueur Simple
-------------

Lorsqu'un coup gagnant existe, il est joué (attaque)
Lorsqu'un coup empêchant un alignement adverse existe, il est joué (défense)
Sinon, un coup aléatoire est joué

"""

class Joueur_Simple():
    def __init__(self):
        pass

    def jouer(self, info):
        pass

"""
-------------
Joueur Avancé
-------------

Identique au joueur simple, mais joue dans un coin au début, ou au centre en second

Le paramètre 'random_factor' (entre 0 et 1) permet d'introduire une dose d'aléatoire :
 - 0 : choix détermistes pour les premier et deuxième coups, ainsi que pour les coups d'attaque ou de défense
 - 1 : complètement aléatoire

"""

class Joueur_Avance():
    def __init__(self, random_factor=0):
        self.__random_factor = random_factor
        pass


    def jouer(self, info):
        if len(info['legal_actions']) == 9 and random.random() > self.__random_factor:
            return random.choice([0,2,6,8])
        elif len(info['legal_actions']) == 8 and 4 in info['legal_actions'] and random.random() > self.__random_factor:
            return 4
        elif len(info['win_actions']) > 0 and random.random() > self.__random_factor:
            return info['win_actions'][0]
        elif len(info['def_actions']) > 0 and random.random() > self.__random_factor:
            return info['def_actions'][0]
        else:
            return random.choice(info['legal_actions'])

    def set_random_factor(self, random_factor):
        self.__random_factor = random_factor